(function () {

    /**
     * replace module name with a custom name for the local-script.
     *
     * All local-script should be attached to the "custom.ls" package.
     * If more than one script is required for an application, a common root package
     * should be created (e.g. "custom.ls.customerName.*").
     */

    var MODULE_NAME = "simple-upload",
        ENABLE_LOGGING = false,
        RECORD_LOG = false,
        logger = shmi.requires("visuals.tools.logging").createLogger(MODULE_NAME, ENABLE_LOGGING, RECORD_LOG),
        fLog = logger.fLog,
        log = logger.log,
        module = shmi.pkg( MODULE_NAME );

    // MODULE CODE - START

    /* private variables */
    
    // other variables
    
    /* private functions */

    /**
     * Implements local-script run function.
     *
     * This function will be called each time a local-script will be enabled.
     *
     * @param {LocalScript} self instance reference of local-script control
     */
    module.run = function (self) {

        //Place your Code here
        var actions = shmi.pkg("visuals.session.userActions"); //get reference to userActions object
        const im = shmi.requires("visuals.session.ItemManager");
        const formSendZIP = document.querySelector("#uploadZIP");
        const formSendCSV = document.querySelector("#uploadCSV");
        let sReq = "";

        // item handler
        itemHandler = im.getItemHandler();

        
        // Ein EventListener wartet auf das submit
        formSendZIP.addEventListener ("submit", async function (evt) {

            evt.preventDefault ();
            const files = document.querySelector('[type=file]').files; 
			let sResult = ""; // debug variable
            let bError = false;

            sResult += `Selected file: ${files[0].name}\n`; // debug information
            sResult += `Selected file type: ${files[0].type}\n`; // debug information

           
            // read name of configuration
            var sItem_NameOfConfiguration = im.readValue("sConfiguration");
            if (sItem_NameOfConfiguration === "")
            {
                bError = true;
                sResult += `error readValue. Please fill out the form data. \n`; // debug information
            }

            // read IP address
            var sIP = im.readValue("sIP");
            if (sIP === "")
            {
                bError = true;
                sResult += `error readValue. Please fill out the form data. \n`; // debug information
            }

            // read User
            var sUser = im.readValue("sUser");
            if (sUser === "")
            {
                bError = true;
                sResult += `error readValue. Please fill out the form data. \n`; // debug information
            }

            // read password
            var sPwd = im.readValue("sPassword");
            if (sPwd === "")
            {
                bError = true;
                sResult += `error readValue. Please fill out the form data. \n`; // debug information
            }



            if (bError === false) {

                // function is active - show progress bar
                im.writeValue("bREST_API_call_Active", 1);

                // check if the right file type was selected by the user
                if (files[0].type === "application/x-zip-compressed")
                {
                    var sHost = `https://${sIP}/`;
                    sResult += `v1: Host     = "${sHost}"\nUser     = "${sUser}"\nPassword = "****"\n\n`;   // debug information
                    sResult += `script "simple-upload" was executed and button "submit" was pressed\n`; // debug information


                    // login to ctrlX CORE
                    try {
                        sReq = sHost + 'identity-manager/api/v1.0/auth/token';
                        var response = await axios.post(sReq, { name: sUser, password: sPwd });
                        if (response === null) {
                            sResult += `AXIOS call failed, check if package-axios is installed.`;
                            bError = true;
                        }
                    }
                    catch (err) {
                        sResult += `AXIOS unable to post request: ${err}\n${sReq}\nPlease check ip, user and password`;
                        bError = true;
                    }

                    if (bError === false) {
                        const token = response.data.access_token;

                        sReq = sHost + `solutions/api/v1/solutions/DefaultSolution/configurations/${sItem_NameOfConfiguration}/archive`;
                        sResult += `\n Request: ${sReq}\n`;
                        sResult += `START: function PUT *.zip-file() \n`;
                    
                        // try to upload a ZIP file
                        try {
                            const response = await axios({
                                                method: "put",
                                                url: sReq,
                                                data: files[0],
                                                headers: {authorization: 'Bearer ' + token, "Content-Type": "application/x-zip-compressed"},
                                });

                            sResult += `Status PUT command: ${response.status} ${response.statusText}\n`;
                            if (response.status >= 200 && response.status < 300)
                            {
                                sResult += `\n\n command was SUCCESSFUL \n`;
                            }
                            }
                            catch (err) {
                                sResult += `Put error: ${err}`;
                                bError = true;
                            }  
                
                    } // end if 

                } // end if
                else // user selected the wrong file type
                {
                    sResult += `Please select a *.ZIP file!!!\n`; // debug information  
                } // end else

            }// end if (bError)

            // write interface (string) value
            im.writeValue("SString", sResult);

            // function finished - hide progress bar
            im.writeValue("bREST_API_call_Active", 0);

        });

// ----------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------
// ----------------------------------------------------------------------------------------------------------

        // Ein EventListener wartet auf das submit
        formSendCSV.addEventListener ("submit", async function (evt) {

            evt.preventDefault ();
            var inputs = document.querySelectorAll('#choose-file-CSV'); 
			let sResult = ""; // debug variable
            let bError = false;

            // check file input field
            if (inputs.length == 1)
            {
                if (inputs[0].files[0] == null)
                {
                    bError = true;
                    sResult += `Please select a file!!!\n`; // debug information 
                }
                else
                {
                    sResult += `file inputs 0: ${inputs[0].files[0].name}\n`; // debug information
                    sResult += `file inputs 0: ${inputs[0].files[0].type}\n`; // debug information
                }
            }
            else
            {
                bError = true;
                sResult += `More than one input field configured!!! \n`; // debug information 
            }
            
           
            // read IP address
            var sIP = im.readValue("sIP");
            if (sIP === "")
            {
                bError = true;
                sResult += `error readValue. Please fill out the form data. \n`; // debug information
            }

            // read User
            var sUser = im.readValue("sUser");
            if (sUser === "")
            {
                bError = true;
                sResult += `error readValue. Please fill out the form data. \n`; // debug information
            }

            // read password
            var sPwd = im.readValue("sPassword");
            if (sPwd === "")
            {
                bError = true;
                sResult += `error readValue. Please fill out the form data. \n`; // debug information
            }


            if (bError === false) {

                // check if the right file type was selected by the user
                if (inputs[0].files[0].type === "text/csv")
                {

                    var sHost = `https://${sIP}/`;
                    sResult += `v2: Host     = "${sHost}"\nUser     = "${sUser}"\nPassword = "****"\n\n`;   // debug information
                    sResult += `script "sendFile()" was executed and button "submit" was pressed\n`; // debug information


                    if (bError === false) {
                        
                        sReq = sHost + `solutions/webdav/appdata/doku/${inputs[0].files[0].name}`;
                        sResult += `\n Request: ${sReq}\n`;
                        sResult += `\n START: function PUT *.csv-file() \n`;
                    
                        // try to upload a file
                        try {
                                const response = await axios({
                                    method: "put",
                                    url: sReq,
                                    data: inputs[0].files[0],
                                    auth: {
                                            username: sUser,
                                            password: sPwd
                                        }
                                                    
                                    });

                                sResult += `\n Status PUT command: ${response.status} ${response.statusText} \n`;
                                if (response.status >= 200 && response.status < 300)
                                {
                                    sResult += `\n\n command was SUCCESSFUL \n`;
                                }
                            }
                            catch (err) {
                                sResult += `Put error: ${err}`;
                                bError = true;
                            }
                
                    } // end if 

                } // end if
                else // user selected the wrong file type
                {
                    sResult += `Please select a *.csv file!!!\n`; // debug information  
                } // end else

            }// end if (bError)


            // function is finished - hide progress bar
            im.writeValue("bREST_API_call_Active", 0);

            // write interface (string) value
            im.writeValue("SString", sResult);

		});


     

        /* called when this local-script is disabled */
        self.onDisable = function () {
            self.run = false; /* from original .onDisable function of LocalScript control */
        };
    };


    // MODULE CODE - END
    fLog("module loaded");
})();
