/**
 * Custom UI-Action 'APIcall_CreateFolder'.
 *
 * Description:
 * using Axios with MKCOL command
 */
(function() {
    var actions = shmi.pkg("visuals.session.userActions"); //get reference to userActions object

    /**
     * UI-Action 'APIcall_CreateFolder' implementation
     *
     * @params {any[]} parameters  configured ui-action parameters
     * ---- Initial parameters, needs to be updated manually when changed ----
     * @param {string} parameters[0]  sIP
     * @param {string} parameters[1]  sUser
     * @param {string} parameters[2]  sPassword
     * @param {string} parameters[3]  sDirectory
     *
     */
    actions["APIcall_CreateFolder"] = async function(parameters) {
        let sReq = "";
        let sResult = "";
        let bError = false;
        let bDoAUpload = false;
        const im = shmi.requires("visuals.session.ItemManager");
        
        // read entered data (total 4 parameters)
        let sIP = im.readValue(parameters[0]);
        var sUser = im.readValue(parameters[1]);
        var sPwd = im.readValue(parameters[2]);
        var sDirectory = im.readValue(parameters[3]);   // get directory

        
        // read IP address
        if (sIP === "")
        {
            bError = true;
            sResult += `Please fill out the form data - IP address. \n`; // debug information
        }
        // read User
        if (sUser === "")
        {
            bError = true;
            sResult += `Please fill out the form data - user. \n`; // debug information
        }
        // read password
        if (sPwd === "")
        {
            bError = true;
            sResult += `Please fill out the form data - password. \n`; // debug information
        }
        // read directory
        if (sDirectory === "")
        {
            bError = true;
            sResult += `Please fill out the form data - directory. \n`; // debug information
        }



        // do something.... ------------------------------------------------------------------------------------
        if (bError === false) 
        {
            // other variables
            var sHost = `https://${sIP}/`;
            sResult = `Host     = "${sHost}"\nUser     = "${sUser}"\nPassword = "****" \n\n`; // debug information

            // function is active - show progress bar
            im.writeValue("bREST_API_call_Active", 1);

            sReq = sHost + sDirectory;
            sResult += `\n Request: ${sReq}\n`;
            sResult += `\n START: create folder \n`;
                    
                // try to upload a file
                try {
                        const response = await axios({
                            method: "mkcol",
                            url: sReq,
                            auth: {
                                    username: sUser,
                                    password: sPwd
                                    }
                                                    
                                });

                            sResult += `\n Status MKCOL command: ${response.status} ${response.statusText} \n`;
                            if (response.status >= 200 && response.status < 300)
                            {
                                sResult += `\n\n MKCOL command was SUCCESSFUL \n`;
                            }
                    }
                    catch (err) {
                        sResult += `MKCOL error: ${err}`;
                        bError = true;
                    }
                

        }// end if (bError)

        // write interface (string) value
        im.writeValue("SString", sResult);

        // function finished - hide progress bar
        im.writeValue("bREST_API_call_Active", 0);

    };
}());