/**
 * Custom UI-Action 'APIcall_DownloadFile'.
 *
 * Description:
 * [Add description here]
 */
(function() {
    var actions = shmi.pkg("visuals.session.userActions"); //get reference to userActions object

    /**
     * UI-Action 'APIcall_Backup' implementation
     *
     * @params {any[]} parameters  configured ui-action parameters
     * @param[0] {string} var name ip address
     * @param[1] {string} var name user
     * @param[2] {string} var name password
     * 
     */

    actions["APIcall_DownloadFile"] = async function(parameters) {
        let sReq = "";
        let sResult = "";
        let bError = false;
        let bDoAUpload = false;
        const im = shmi.requires("visuals.session.ItemManager");
        
        // read entered data (total 4 parameters)
        let sIP = im.readValue(parameters[0]);
        var sUser = im.readValue(parameters[1]);
        var sPwd = im.readValue(parameters[2]);
        

        // read IP address
        if (sIP === "")
        {
            bError = true;
            sResult += `Please fill out the form data - IP address. \n`; // debug information
        }
        // read User
        if (sUser === "")
        {
            bError = true;
            sResult += `Please fill out the form data - user. \n`; // debug information
        }
        // read password
        if (sPwd === "")
        {
            bError = true;
            sResult += `Please fill out the form data - password. \n`; // debug information
        }
        

        // do something.... ------------------------------------------------------------------------------------
        if (bError === false) 
        {
            // other variables
            var sHost = `https://${sIP}/`;
            sResult = `Host     = "${sHost}"\nUser     = "${sUser}"\nPassword = "****" \n\n`; // debug information

            // function is active - show progress bar
            im.writeValue("bREST_API_call_Active", 1);

            sReq = sHost + "solutions/webdav/appdata/plc/run/linux-gcc-aarch64/data/Daten.RecipeDataSave_1.csv";
            sResult += `\n Request: ${sReq}\n`;
            sResult += `\n START: get csv-file \n`;
                    
                // try to upload a file
                try {
                        const response = await axios({
                            method: "get",
                            url: sReq,
                            auth: {
                                    username: sUser,
                                    password: sPwd
                                    }
                                                    
                                });

                            sResult += `\n Status GET command: ${response.status} ${response.statusText} \n`;
                            if (response.status >= 200 && response.status < 300)
                            {
                                sResult += `\n\n get command was SUCCESSFUL \n`;
                            }


                            const url = window.URL.createObjectURL(new Blob([response.data]));
                            const link = document.createElement('a');
                            link.href = url;
                            link.setAttribute('download', 'My-CSV-File.csv');
                            document.body.appendChild(link);
                            link.click();


                    }
                    catch (err) {
                        sResult += `get error: ${err}`;
                        bError = true;
                    }
                

        }// end if (bError)

        // write interface (string) value
        im.writeValue("SString", sResult);

        // function finished - hide progress bar
        im.writeValue("bREST_API_call_Active", 0);

    };
}());